/*
 * Initialisation for the stage 1 payload with support for boot parameters.
 *
 * Copyright (C) 2009 Qi Hardware Inc.
 * Author: Wolfgang Spraul <wolfgang@sharism.cc>
 *
 * Copyright (C) 2015 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

	.text
	.extern c_main
	.globl _start
	.set noreorder
_start:
	b	real_start
	nop
        // 8 words for firmware parameters (0x80002008), struct fw_args
	.word	0x0
	.word	0x0
	.word	0x0
	.word	0x0
	.word	0x0
	.word	0x0
	.word	0x0
	.word	0x0
real_start:
	/*
	 * setup stack, jump to C code
	 */
	la	$29, 0x80004000	/* sp */
	j	c_main
	nop

	.set reorder
